
#include "PC_Comm.h"
#include "ADC.h"
#include "BCD.h"
#include "FSR.h"
#include "Pot.h"
#include "PWM.h"
#include "main.h"

int butterfly = 2;

char servoNr_c;
int servoNr;
float ftLo[4] = {999,999,999,999};
float ftHi[4] = {999,999,999,999};

void init()
{
	// initier drivere: 
	init_PC_Comm();
	init_FSR();
	sendString("FSR initialisert\r");
	init_Pot();
	sendString("Potmeter initialisert\r");
	init_PWM();
	sendString("PWM/Servo initialisert\r");
	
	//sett pwm-frekvens 50 Hz
	set_freq(50); 
	
	//fortell om tilgjengelige kommandoer
	sendString("\r");
	sendString("EPP starter epp\r");
	sendString("freqXXX setter frekvens\r");
	sendString("voltX leser spenning fra ADCX\r");
	sendString("svXctcXXX setter servoposisjon for servo X\r");
	sendString("s stopper PWM\r");
}


int main(void)
{
	init();
	
	//evig lkke
	for(;;) 
	{	
		 //PC_Comm();	 
	}
	
	EPP();
		 
	return 0;
}

//her kommer selve EPP-funksjonen! 
void EPP()
{

for(;;){//uendelig lkke
	if (butterfly==1){
		float FSR1 = read_FSR(1);
		float FSR2 = read_FSR(2);
		
		
		if (FSR1 > ftHi[0]){
			//kraft oppover fra servo 3 skal matche fsr1
		}else if (FSR1 < ftHi[0] && FSR1 > ftLo[0]){
			//inkrementer servo 3
			increment_position(3);
		}else{
			//gjr ikkeno
		}	

		if (FSR2 > ftHi[1]){
			//kraft nedover fra servo 3 skal matche fsr1
		}else if (FSR1 < ftHi[1] && FSR1 > ftLo[1]){
			//dekrementer servo 3
			decrement_position(4);
		}else{
			//gjr ikkeno
		}
		
		float pot1 = read_Pot(1);
		set_position(pot1,1); //sett posisjon p servo1 = pot1, alts samme prosent
		
	} else if (butterfly == 2){
		float FSR3 = read_FSR(3);
		float FSR4 = read_FSR(4);
		
		
		if (FSR3 > ftHi[2]){
			//kraft oppover fra servo 4 skal matche fsr3
		}else if (FSR3 < ftHi[2] && FSR3 > ftLo[2]){
			//dekrementer servo 4
			decrement_position(3);
		}else{
			//gjr ikkeno
		}	

		if (FSR4 > ftHi[3]){
			//kraft oppover fra servo 4 skal matche fsr4
		}else if (FSR4 < ftHi[3] && FSR4 > ftLo[3]){
			//inkrementer servo 4
			increment_position(4);
		}else{
			//gjr ikkeno
		}
		
		float pot2 = read_Pot(2);
		set_position(pot2,2); //sett posisjon p servo1 = pot1 i prosent
	}
	
	PC_Comm(); //sjekk for kommando fra PC (vil i de fleste tilfeller ikke vre tilkoblet)
}//slutt p uendelig lkke
	
	
}


//definer hva som skjer nr jeg skriver inn noe p pc'en (via PC_Comm.c)
//basert p programvare fra "c programming for microcontrollers" (Joe Pardue, 2005)
void parseInput(char s[])
{
	// parse first character	
	switch (s[0])
	{
	
		case 'e':
			if( (s[1] == 'p') && (s[2] == 'p') )
			EPP();
			break;
		case 'f':
			if( (s[1] == 'r') && (s[2] == 'e') && (s[3] == 'q') )
			parse_freq(s);
			break;
		case 'v':
			if( (s[1] == 'o') && (s[2] == 'l')&& (s[3] == 't'))
			read_FSR(s[4]);
			break;
		case 's':
			if( (s[1] == 'v') ){
					servoNr = s[2]-48; //ascii 48 = int 0 
				if( (s[3] == 'c') && (s[4] == 't') && (s[5] == 'c')){
					parse_ctc(s, servoNr);
				}
			}
			else{
			sendString("stopper PWM.\r");
			stop_PWM();
			}
			break;


		default:
			sendString("\rYou sent: '");
			sendChar(s[0]);
			sendString("' - I don't understand.\r");
			break;
		
	}
	s[0] = '\0';
}

//hentet fra "c programming for microcontrollers" (Joe Pardue, 2005):
//Calibrate the internal OSCCAL byte, using the external 
//32,768 kHz crystal as reference
void OSCCAL_calibration(void)
{
    unsigned char calibrate = 0;//FALSE;
    int temp;
    unsigned char tempL;

    CLKPR = (1<<CLKPCE);        // set Clock Prescaler Change Enable
	
    // set prescaler = 8, Inter RC 8Mhz / 8 = 1Mhz
    CLKPR = (1<<CLKPS1) | (1<<CLKPS0); //deler 8MHz-klokken p 8, og gir 1MHz.
	
    
    TIMSK2 = 0;             //disable OCIE2A and TOIE2

    ASSR = (1<<AS2);        //select asynchronous operation of timer2 (32,768kHz)
    
    OCR2A = 200;            // set timer2 compare value 

    TIMSK0 = 0;             // delete any interrupt sources
        
    TCCR1B = (1<<CS10);     // start timer1 with no prescaling
    TCCR2A = (1<<CS20);     // start timer2 with no prescaling

    while((ASSR & 0x01) | (ASSR & 0x04));       //wait for TCN2UB and TCR2UB to be cleared

    // wait for external crystal to stabilise
	for(int i = 0; i < 10; i++)
			_delay_loop_2(30000);   
			
    while(!calibrate)
    {
        cli(); // mt __disable_interrupt();  // disable global interrupt
        
        TIFR1 = 0xFF;   // delete TIFR1 flags
        TIFR2 = 0xFF;   // delete TIFR2 flags
        
        TCNT1H = 0;     // clear timer1 counter
        TCNT1L = 0;
        TCNT2 = 0;      // clear timer2 counter
           
        while ( !(TIFR2 && (1<<OCF2A)) );   // wait for timer2 compareflag
    
        TCCR1B = 0; // stop timer1

        sei(); // __enable_interrupt();  // enable global interrupt
    
        if ( (TIFR1 && (1<<TOV1)) )
        {
            temp = 0xFFFF;      // if timer1 overflows, set the temp to 0xFFFF
        }
        else
        {   // read out the timer1 counter value
            tempL = TCNT1L;
            temp = TCNT1H;
            temp = (temp << 8);
            temp += tempL;
        }
    
        if (temp > 6250)
        {
            OSCCAL--;   // the internRC oscillator runs to fast, decrease the OSCCAL
        }
        else if (temp < 6120)
        {
            OSCCAL++;   // the internRC oscillator runs to slow, increase the OSCCAL
        }
        else
            calibrate = 1;//TRUE;   // the interRC is correct
    
        TCCR1B = (1<<CS10); // start timer1
    }
}